## NAME

r.cross - Creates a cross product of the category values from multiple raster map layers.

## KEYWORDS

raster, statistics

## SYNOPSIS

r.cross
r.cross --help
r.cross [-z] input=string[,string,...] output=name [--overwrite] [--help] [--verbose] [--quiet] [--ui]

### Flags:

-z
  Non-NULL data only
--overwrite
  Allow output files to overwrite existing files
--help
  Print usage summary
--verbose
  Verbose module output
--quiet
  Quiet module output
--ui
  Force launching GUI dialog

### Parameters:

input=string[,string,...] [required]
  Names of 2-30 input raster maps
output=name [required]
  Name for output raster map

## DESCRIPTION

r.cross creates an output raster map layer representing all unique combinations of category values in the raster input layers (input=name,name,name, ...). At least two, but not more than ten, input map layers must be specified. The user must also specify a name to be assigned to the output raster map layer created by r.cross.

## OPTIONS

The program will be run non-interactively if the user specifies the names of between 2-10 raster map layers be used as input, and the name of a raster map layer to hold program output.

With the -z flag NULL values are not crossed. This means that if a NULL value occurs in any input data layer, this combination is ignored, even if other data layers contain non-NULL data. In the example given below, use of the -z option would cause 3 categories to be generated instead of 5.

If the -z flag is not specified, then map layer combinations in which some values are NULL will be assigned a unique category value in the resulting output map.

Category values in the new output map layer will be the cross-product of the category values from these existing input map layers.

## EXAMPLE

For example, suppose that, using two raster map layers, the following combinations occur:

              map1   map2
              ___________
              NULL    1
              NULL    2
               1      1
               1      2
               2      4

r.cross would produce a new raster map layer with 5 categories:

              map1   map2   output
              ____________________
              NULL    1       0
              NULL    2       1
               1      1       2
               1      2       3
               2      4       4

Note: The actual category value assigned to a particular combination in the result map layer is dependent on the order in which the combinations occur in the input map layer data and can be considered essentially random. The example given here is illustrative only.

## SUPPORT FILES

The category file created for the output raster map layer describes the combinations of input map layer category values which generated each category. In the above example, the category labels would be:

              category   category
              value      label
              ______________________________
                 0       layer1(0) layer2(1)
                 1       layer1(0) layer2(2)
                 2       layer1(1) layer2(1)
                 3       layer1(1) layer2(2)
                 4       layer1(2) layer2(4)

A random color table is also generated for the output map layer.

## SEE ALSO

r.covar, r.stats

## AUTHOR

Michael Shapiro, U.S. Army Construction Engineering Research Laboratory

## SOURCE CODE

Available at: r.cross source code (history)

Main index | Raster index | Topics index | Keywords index | Graphical index | Full index

© 2003-2020 GRASS Development Team, GRASS GIS 7.9.dev Reference Manual